#!/bin/bash

### 變數區 ###
input_account=""
input_date=""
jet=""
#--------------------------------

# 使用 whmapi1 列出所有經銷帳號
response=$(whmapi1 --output=jsonpretty listresellers)

# 使用 jq 解析 JSON 回應並檢查 data.reseller 是否為空
is_empty=$(echo "$response" | jq -r '.data.reseller | if length == 0 then "true" else "false" end')

# 判斷 data.reseller 是否為空並輸出結果
if [ "$is_empty" == "true" ]; then
    echo "此主機非經銷主機，不執行此程式!"
    exit
else
    :
fi






if [ -e /usr/bin/jetbackup ]; then
    jet="4"
fi

if [ -e /usr/bin/jetbackup5 ]; then
    jet="5"
fi



# 使用 whmapi1 列出所有經銷帳號
reseller_accounts=$(whmapi1 --output=jsonpretty listresellers | jq '.data.reseller[]' | sed 's/\"//g') 
for reseller_account in $reseller_accounts; do
    reseller_account_accounts=$(whmapi1 --output=jsonpretty listaccts | jq --arg account $reseller_account  '.data.acct[] | select(.owner == $account) |.user' | sed 's/\"//g')
	
	for reseller_account_account in $reseller_account_accounts; do
	    echo "經銷子帳號: $reseller_account_account   經銷主帳號: $reseller_account"
	    diskquota_value=""
	    bandwidth_value=""

	    if [ "$jet" == "4" ]; then
	        snap_name=$(ls -lt --time-style=long-iso /backup/jetbackup/jetbackup_1_1_*/${reseller_account_account}/snap.*/jetbackup.index | grep 2024-05-27 | awk -F'/' '{for (i=1; i<=NF; i++) if ($i ~ /^snap\./) print $i}')
	    
	    diskquota_value=$(expr $(cat /backup/jetbackup/jetbackup_1_1_*/${reseller_account_account}/${snap_name}/quota) \* 1024 \* 1024)
	    bandwidth_value=$(cat /backup/jetbackup/jetbackup_1_1_*/${reseller_account_account}/${snap_name}/cp/${reseller_account_account} | grep BWLIMIT |awk -F 'BWLIMIT=' '{print $2}')

		if [ -z "$diskquota_value" ] || [ -z "$bandwidth_value" ]; then
		   continue 
		fi

                mkdir -p /home/steven_yj/reseller_20240527/$reseller_account
	        touch /home/steven_yj/reseller_20240527/$reseller_account/${reseller_account_account}.txt
		output_dir="/home/steven_yj/reseller_20240527/$reseller_account"
                output_file="${output_dir}/${reseller_account_account}.txt"
		#echo "whmapi1 --output=jsonpretty modifyacct user=${reseller_account_account} QUOTA=${diskquota_value} BWLIMIT=${bandwidth_value}" > /home/steven_yj/reseller_20240527/$reseller_account/${reseller_account_account}.txt
		echo "whmapi1 --output=jsonpretty modifyacct user=${reseller_account_account} QUOTA=${diskquota_value} BWLIMIT=${bandwidth_value}" > "$output_file"
	    fi

            if [ "$jet" == "5" ]; then
	        snap_name=$(ls -lt --time-style=long-iso /backup/jetbackup/jetbackup_1_1_*/${reseller_account_account}_*/snap.*/jetbackup.index | grep 2024-05-27 | awk -F'/' '{for (i=1; i<=NF; i++) if ($i ~ /^snap\./) print $i}')
                diskquota_value=$(expr $(cat /backup/jetbackup/jetbackup_1_1_*/${reseller_account_account}_*/${snap_name}/config/quota) \* 1024 \* 1024) 
	        bandwidth_value=$(cat /backup/jetbackup/jetbackup_1_1_*/${reseller_account_account}_*/${snap_name}/config/cp/${reseller_account_account} | grep BWLIMIT |awk -F 'BWLIMIT=' '{print $2}')
	 	
		if [ -z "$diskquota_value" ] || [ -z "$bandwidth_value" ]; then
                   continue 
                fi
                mkdir -p /home/steven_yj/reseller_20240527/$reseller_account
                touch /home/steven_yj/reseller_20240527/$reseller_account/${reseller_account_account}.txt
		output_dir="/home/steven_yj/reseller_20240527/$reseller_account"
                output_file="${output_dir}/${reseller_account_account}.txt"
		#echo "whmapi1 --output=jsonpretty modifyacct user=${reseller_account_account} QUOTA=${diskquota_value} BWLIMIT=${bandwidth_value}" > /home/steven_yj/reseller_20240527/$reseller_account/${reseller_account_account}.txt
		echo "whmapi1 --output=jsonpretty modifyacct user=${reseller_account_account} QUOTA=${diskquota_value} BWLIMIT=${bandwidth_value}" > "$output_file"
            fi

	done
done
